#!/usr/bin/perl

#↑Perlのパス サーバーのマニュアルをみて確認する

use Encode;

#enquete ver.2 

#設置の仕方、カスタマイズの仕方などはreadme.txtをごらんください。

#-------------- 基本設定------------

$sendmail='/usr/sbin/sendmail';	#sendmailのパス サーバーのマニュアルで調べて記入
$mailto='xxx@xxx.xxx';	#メールを受け取る人(あなた)のメールアドレス
$csv='1';			#質問をCSVに記録するか(0:しない 1:する)
$logfile='data.csv';		#csvファイル
$mailsub='アンケート投票';	#受け取るメールの件名

$html_chk='check.html';		#確認画面のスキン(初期状態では使用しません)
$html_end='thanks.html';	#終了画面のHTML

@que=(
'q1',
'q2',
'q3',
'q4',
'q5',
'q6',
);

@que_name=(
'性別',
'このサイトの感想',
'好きな動物',
'誕生月',
'ひとこと',
'要望など',
);
#アンケートの項目を設定
#@queにはq1 q2 q3と質問のIDを設定して、
#@que_nameにはそれに対応して質問名を日本語で記入

@kaigyo=(
'q6',
);
#@queに設定したIDのうち、改行の必要のあるもの(フォームがtextareaのもの)を設定

@checkbox=(
'q3',
);
#@queに設定したIDのうち、複数選択のもの(フォームがcheckboxのもの)を設定

@require=(

);

#@queに設定したIDのうち、入力必須にするものを設定
#@require=(
#'q1',
#);
#のように設定します。

#---------------- 制限など ---------------------

$maxsize=10000;		#投稿量の限度(バイト) 日本語は1文字2バイトです。

#------------ 設定はここまで。--------------

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'} > $maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	&Dcd;
}

sub Dcd{
	my(@pairs,$pair,$value,$name,$kflag,$kaigyo);
	@pairs=split(/&/,$buff);
	foreach $pair (@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value=~s/</&lt;/g;
		$value=~s/>/&gt;/g;
		$value=~s/&/&amp;/g;
		$value=~s/"/&quot;/g;
		$value=~s/,//g;
		$name=~tr/+/ /;
		$name=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$kflag=grep{$_ eq $name}@kaigyo;
		$cflag=grep{$_ eq $name}@checkbox;
		if($kflag){
			$value=~s/\x0D\x0A/\n/g;
			$value=~s/\x0D/\n/g;
			$value=~s/\x0A/\n/g;
		}
		else{
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}
		if($cflag){
			push @{$CK{$name}},$value;
		}
		$FORM{$name}=$value;
	}

}

if($FORM{'mode'} eq "send"){
	&Send;
}
elsif($FORM{'mode'} eq "check"){
	&Check;
}

sub Check{
my($skinline,$head,$footer,$dummy,$tr,$tr_d,$i,$kflag,$m_tmp,$input,@keys,$l,$v);

foreach $l(@require){
	if($FORM{$l} eq ""){
		$i=0;
		foreach $v(@que){
			if($l eq $v){
				last;
			}
			$i++;
		}
		&error("$que_name[$i]が入力されていません。");
	}
}

unless(open(HTML, $html_chk)){
	&error("$html_chkが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);
($head,$dummy)=split(/<!--start-->/,$skinline);
if($head eq ""){
	&error("$html_chkに<!--start-->が書かれていません。");
}
($tr,$footer)=split(/<!--end-->/,$dummy);
if($tr eq ""){
	&error("$html_chkに<!--end-->が書かれていません。");
}
@keys=%CK;
foreach(@keys){
	if(@{$CK{$_}}){
		$FORM{$_}=join(" ",@{$CK{$_}});
	}
}

$i=0;
foreach $l(@que){
	$tr_d=$tr;
	$kflag=grep{$_ eq $l}@kaigyo;
	if($kflag){
		$m_tmp=$FORM{$l};
		$m_tmp=~s/\n/<br>/g;
		$tr_d =~ s/<!--value-->/$m_tmp/;
	}
	else{
		$tr_d =~ s/<!--value-->/$FORM{$l}/;
	}

	$tr_d =~ s/<!--form-->/$que_name[$i]/;
	$input.=qq(<input type="hidden" name="$l" value="$FORM{$l}">\n);
	$all.=$tr_d;

$i++;
}
$input.=qq(<input type="hidden" name="check" value="1">\n);

$footer =~ s/<!--input-->/$input/;

print "Content-type: text/html\n\n";
print $head;
print $all;
print $footer;
exit;

}


sub Send{
my($i,$line,$allline,$mailbody,$mailname,@keys);

foreach $l(@require){
	if($FORM{$l} eq ""){
		$i=0;
		foreach $v(@que){
			if($l eq $v){
				last;
			}
			$i++;
		}
		&error("$que_name[$i]が入力されていません。");
	}
}


if(!$FORM{'check'}){
	@keys=%CK;
	foreach(@keys){
		if(@{$CK{$_}}){
			$FORM{$_}=join(" ",@{$CK{$_}});
		}
	}
}
$i=0;
foreach(@que){
	$line="□".$que_name[$i].": ".$FORM{$_}."\n";
	$allline.=$line;
	$i++;
}

$mailbody=<<"EOM";
$allline
EOM

$mailbody.="\n";
$mailbody.="IP adress : $ENV{'REMOTE_ADDR'}\n";
$mailbody.="Host      : $ENV{'REMOTE_HOST'}\n";
$mailbody.="User Agent: $ENV{'HTTP_USER_AGENT'}\n";


$mailbody=encode('jis',decode('utf8',$mailbody),Encode::FB_XMLCREF);

$mailbody=~s/\e\(B&#xff5e;\e\$B/\e\$B\x21\x41/g;
$mailbody=~s/\e\(B&#xff5e;/\e\$B\x21\x41\e\(B/g;
$mailbody=~s/&#xff5e;\e\$B/\e\$B\x21\x41/g;
$mailbody=~s/&#xff5e;/\e\$B\x21\x41\e\(B/g;

$mailbody=~s/\e\(B&#xff0d;\e\$B/\e\$B\x21\x3e/g;
$mailbody=~s/\e\(B&#xff0d;/\e\$B\x21\x3e\e\(B/g;
$mailbody=~s/&#xff0d;\e\$B/\e\$B\x21\x3e/g;
$mailbody=~s/&#xff0d;/\e\$B\x21\x3e\e\(B/g;

if($mailsub){
	$mailsub=encode('jis',decode('utf8',$mailsub));
	$mailsub=&mail64encode($mailsub);
}


$mailname=$mailto;

if(!open(MAIL, "| $sendmail -t")){
	&error("メール送信できません。sendmailのパス等を確認してください。");
}
print MAIL "To: $mailto\n";
print MAIL "From: $mailname\n";
print MAIL "Subject: $mailsub\n";
print MAIL "MIME-Version: 1.0\n";
print MAIL "Content-Type: text/plain\; charset=\"ISO-2022-JP\"\n";
print MAIL "Content-Transfer-Encoding: 7bit\n\n";
print MAIL "$mailbody\n";
close(MAIL);

if($csv){
	&Csv;
}
&End;
}

sub Csv{
my($line,$i);
$i=0;

foreach(@kaigyo){
	$FORM{$_}=~s/\n//g;
}

foreach(@que){
	$line.=$FORM{$_}.",";
	$i++;
}

$line.="\n";
unless(open(FILE,">>$logfile")){
	&error("$logfileが開けません。ファイルを確認してください。");
}
print FILE $line;
close FILE;

}

sub End{
unless(open(HTML,$html_end)){
	&error("$html_endが開けません。ファイルを確認してください。");
}

print "Content-type: text/html\n\n";
while(<HTML>){
	print $_;
}
close HTML;
exit;
}


sub mail64encode {
my($tmp_bun) = $_[0];
$tmp_bun = &base64encode($tmp_bun);
return("=?ISO-2022-JP?B?${tmp_bun}?=");
}

sub base64encode {
my($base) = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
my($x, $y, $z, $i);
$x = unpack("B*", $_[0]);
for ($i = 0; $y = substr($x, $i, 6); $i += 6) {
$z .= substr($base, ord(pack("B*", "00" . $y)), 1);
if (length($y) == 2){
$z .= "==";
}elsif (length($y) == 4){
$z .= "=";
}
}
return($z);
}



sub error{
print <<EOM;
Content-type: text/html

<html>
<head>
<META http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<style type="text/css">
div,td{font-size:10pt}
</style>
</head>
<body>
<br>
<br>
<div align="center"><b><font color="#ff0000">ERROR</font></b>
<br><br>
$_[0]

</div>
</body>
</html>
EOM
exit;
}
exit;